﻿using HEAL.Attic;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using System.Collections.Generic;

namespace HeuristicLab.Algorithms.EvolvmentModelsOfModels {
  [Item("DistanceMap", "A map of models of models of models")]
  [StorableType("456692FB-2149-4359-8106-45D59D2D7FA0")]
  public class EMMDisatanceMap : EMMMapBase<ISymbolicExpressionTree> {

    // Under the work now. Do not take into account =)
    #region conctructors
    [StorableConstructor]
    protected EMMDisatanceMap(StorableConstructorFlag _) : base(_) { }
    public EMMDisatanceMap() : this(1) { }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new EMMDisatanceMap(this, cloner);
    }
    public EMMDisatanceMap(int k) : base(k) { ModelSet = new List<ISymbolicExpressionTree>(); }
    public EMMDisatanceMap(EMMDisatanceMap original, Cloner cloner) : base(original, cloner) { }
    #endregion
    #region MapApplayFunctions
    override public void CreateMap(IRandom random, int k) {
      K = Map.Count;
      ApplyDistanceMapCreationAlgorithm(random, Distances, Map, K);
      for (int i = 0; i < Map.Count; i++) {
        ClusterNumber.Add(i);
      }
    }
    public static void ApplyDistanceMapCreationAlgorithm(IRandom random, double[,] distances, List<List<int>> map, int k, int neghboorNumber = 10) {
      int mapSize = distances.GetLength(0);
      List<double> currentList = new List<double>();
      for (int i = 0; i < mapSize; i++) {
        map.Add(new List<int>());
        for (int j = 0; j < mapSize; j++) {
          currentList.Add(distances[i, j]);
        }
        map[i].Add(HelpFunctions.ChooseMinElementIndex(currentList));
        while (map[i].Count < neghboorNumber) {
          map[i].Add(HelpFunctions.ChooseMinElementIndex(currentList, i, map[i]));
        }
        currentList.Clear();
      }
    }

    override public ISymbolicExpressionTree NewModelForInizializtionNotTree(IRandom random, out int cluster, out int treeNumber) {
      return NewModelForInizializtion(random, out cluster, out treeNumber);
    }
    #endregion
  }
}
